/*
 * tcp_defs.h
 *
 *
 */

#ifndef TCP_DEFS_H_
#define TCP_DEFS_H_

#include <lwip/tcp.h>
#include <stdint.h>

typedef enum  {
    TCP_RECV_MSG,
    TCP_ERROR_MSG,
    TCP_SEND_MSG,
    TCP_CLOSE_MSG
} TCP_MESSAGE;

typedef struct {
    TCP_MESSAGE type;
    void *arg;
    struct tcp_pcb* tpcb;
    struct pbuf *p;
    err_t err;
} tcpPacket;

enum tcp_server_states
{
  ES_NONE = 0,
  ES_ACCEPTED,
  ES_RECEIVED,
  ES_CLOSING
};

struct tcp_server_struct
{
  uint8_t state;             /* current connection state */
  struct tcp_pcb *pcb;    /* pointer on the current tcp_pcb */
  struct pbuf *p;         /* pointer on the received/to be transmitted pbuf */
};



#endif /* TCP_DEFS_H_ */
